//Functions
freeslot("MT_METALIXSHOT", "MT_CHAOSKNUXAURA", "S_PLAY_TAILSSWIPE", "sfx_csroar", "sfx_nuexp", "sfx_drkthk")

if not extrachars
    rawset(_G, "extrachars", {})
end
extrachars["sonic"] = {SKINCOLOR_WHITE, 1}
extrachars["knuckles"] = {SKINCOLOR_EMERALD, 3}
extrachars["metalsonic"] = {SKINCOLOR_HYPERMETALLIX, 5}

extrachars.ColourShiftTics = 20	-- how long it takes to go from colour to colour
extrachars.ColourShiftDefault = {SKINCOLOR_LIME, SKINCOLOR_NEON, SKINCOLOR_SAPPHIRE, SKINCOLOR_CYAN, SKINCOLOR_SUNSET, SKINCOLOR_FLAME, SKINCOLOR_SILVER}

extrachars.ResetHyperColors = function(player)
	player.hyper_shiftcolors = nil
	player.mo.hyper_shifttimer = nil	-- god...
	player.hyper_colourshift_delay = nil
end

if not flyingchars
    rawset(_G, "flyingchars", {})
end
flyingchars["metalsonic"] = {1, 2}

sfxinfo[sfx_nuexp].caption = "Almighty Explosion"
sfxinfo[sfx_drkthk].caption = "Dark Thok"
sfxinfo[sfx_csroar].caption = "Knuckles Shouting"
sfxinfo[sfx_nuexp] = {priority = 9999999,flags = SF_NOMULTIPLESOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND}

rawset(_G, "P_CreateRingOfItems", function(player, amount, underwatermobj, mobj, dist, zthrust)
	if player.mo and player.mo.valid
		for i = 1, amount
			local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and underwatermobj or mobj)
			dust.eflags = player.mo.eflags & MFE_VERTICALFLIP
			P_InstaThrust(dust, i*ANGLE_22h, dist*player.mo.scale)
			dust.momz = zthrust*P_MobjFlip(player.mo)*player.mo.scale
		end
	end
end)

rawset(_G, "CheckIfCanExecute", function(player)
	if player.mo and player.mo.valid
		if (player.powers[pw_carry] or player.playerstate == PST_LIVE or not P_PlayerInPain(player) or not player.finished)
	return true end
	end
end)

rawset(_G, "P_PlayerGetMovementCommand", function(player, num)
	if player.mo and player.mo.valid
		if (player.cmd.forwardmove >= num or player.cmd.sidemove >= num or (player.cmd.forwardmove < num or player.cmd.sidemove < num))
	return true end
	end
end)

COM_AddCommand("debug_s&mchars_form", function(p, arg)
		if p.mo and p.mo.valid
		
		if (arg == 1 or string.lower(arg) == "super") and not p.powers[pw_super] //Super Form
			emeralds = $ | EMERALD1|EMERALD2|EMERALD3|EMERALD4|EMERALD5|EMERALD6|EMERALD7
			p.rings = 999
			S_StartSound(p.mo,sfx_supert)
			P_DoSuperTransformation(p, false)
		end
		if (arg == 2 or string.lower(arg) == "hyper") and not p.powers[pw_super] and not p.smhyper //Hyper Form
			emeralds = $ | EMERALD1|EMERALD2|EMERALD3|EMERALD4|EMERALD5|EMERALD6|EMERALD7
			p.rings = 999
			S_StartSound(p.mo,sfx_supert)
			P_DoSuperTransformation(p, false)
			p.smhyper = true
			p.hyper_colorized = true
		end
        if (arg == 3 or string.lower(arg) == "dark")
			emeralds = $ | EMERALD1|EMERALD2|EMERALD3|EMERALD4|EMERALD5|EMERALD6|EMERALD7
			p.rings = 999
			S_StartSound(p.mo,sfx_supert)
			P_DoSuperTransformation(p, false)
			p.darkform = true
		end
	end
end, COM_ADMIN)

COM_AddCommand("eca_hypermusic", function(p)
	if not p.hyper_music
		p.hyper_music = true
		CONS_Printf(p, "\x82Hyper Music will now play when hyper!")
	else
		p.hyper_music = false
		CONS_Printf(p, "\x83Hyper Music will no longer play when hyper.")
	end
	if p.mo
	S_StartSound(p.mo, sfx_tink, p)
	end
end)
			
addHook("MobjThinker", function(aura)
    if aura and aura.valid then
    
        if aura.color == SKINCOLOR_BLACK
        and (aura.target and aura.target.valid)
        and (aura.target.skin ~= "sonic" or aura.target.player.darkform ~= true)
            P_RemoveMobj(aura)
        elseif aura.color == SKINCOLOR_CHAOS_KNUX1
        and (aura.target and aura.target.valid)
        and aura.target.skin != "knuckles"
            P_RemoveMobj(aura)
        end
    end
end, MT_CHAOSKNUXAURA)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	
		if player.mo.skin == "sonic"
			//Sonics part of the code
			if not player.speedtimer
				player.speedtimer = 0
			end
			if not player.airtime
				player.airtime = 0
			end
			if not player.flying
				player.flying = false
			end
			if not player.doublestopper
				player.doublestopper = 0
			end
			if not player.super_doublejump
				player.super_doublejump = 0
			end
			if not player.doublejumped
				player.doublejumped = 0
			end
			if not player.sboosting
				player.sboosting = false
			end
			if not player.uncurled
				player.uncurled = 0
			end
			if not player.uncurledtime
				player.uncurledtime = 0
			end
			if not player.spinHeld
				player.spinHeld = 0
			end
			if not player.jumptimer
				player.jumptimer = 0
			end
            if not player.darkform
                player.darkform = false
            end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid
    
        extrachars.ResetHyperColors(player)
	
		if player.last_music == nil
			player.last_music = 0
		end
		player.last_music = S_MusicName()
		player.digging = 0
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	
	local pmo = player.mo
	
		local normalspeed = skins[pmo.skin].normalspeed
		local hyperspeed = skins[pmo.skin].normalspeed*2
		
		if not player.smhyper 
		and extrachars[pmo.skin]
			player.smhyper = false
		end
        if not (pmo.skin == "sonic")
        or not (player.powers[pw_super])
            player.darkform = false
        end
		if player.hyper_colorized == nil
		and extrachars[pmo.skin]
			player.hyper_colorized = false
		end
		if player.hyper_music == nil
			player.hyper_music = true
		end
	
		if player.smhyper
		
		if (pmo.state >= S_PLAY_SUPER_TRANS5 and pmo.state <= S_PLAY_SUPER_TRANS6)
		and not player.hyper_colorized
			player.hyper_colorized = true
		end
		
		player.normalspeed = hyperspeed
		
		if (pmo.eflags & MFE_UNDERWATER)
			player.powers[pw_underwater] = 0
		end
		if P_InSpaceSector(pmo)
			player.powers[pw_spacetime] = 0
		end
		if (leveltime % 35 == 18)
			P_GivePlayerRings(player, -1)
		end
	end
	if (player.cmd.buttons & BT_USE) and (player.pflags & PF_JUMPED
	and (pmo.state == S_PLAY_JUMP or pmo.state == S_PLAY_ROLL) and player.powers[pw_super] 
	and not player.smhyper and not player.darkform and not player.chaoscooldown and extrachars[player.mo.skin] and player.rings >= 100)
			S_StartSound(pmo,sfx_supert)
			P_SetMobjStateNF(pmo, S_PLAY_SUPER_TRANS1)
			pmo.state = S_PLAY_SUPER_TRANS1
			pmo.frame = A
			player.smhyper = true
            if pmo.skin == "knuckles"
            and player.rings >= 300
            and not player.chaoscooldown
                S_StartSound(pmo,sfx_supert)
                S_StartSound(pmo,sfx_csroar)
                S_StartSound(pmo,sfx_nuexp)
                P_SetMobjStateNF(pmo, S_PLAY_SUPER_TRANS1)
                pmo.state = S_PLAY_SUPER_TRANS1
                pmo.frame = A
                player.hyper_colorized = true
                P_NukeEnemies(pmo, player.mo, 9214*FRACUNIT)
                P_StartQuake(90*FRACUNIT, 2*TICRATE)
                for a=1,151 do
                    local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
                    explode.colorized = true
                    explode.color = SKINCOLOR_EMERALD
                    explode.blendmode = AST_ADD
                    explode.momx = P_RandomRange(-32768, 32767) * 64
                    explode.momy = P_RandomRange(-32768, 32767) * 64
                    explode.momz = P_RandomFixed() * 64
                end
            end
		end	
	if (player.cmd.buttons & BT_CUSTOM2 and player.cmd.buttons & BT_USE) and (player.pflags & PF_JUMPED
	and (pmo.state == S_PLAY_JUMP or pmo.state == S_PLAY_ROLL)
	and player.smhyper)
			S_StartSound(pmo, sfx_s3k66)
			P_FlashPal(player, PAL_MIXUP, 5)
			for d = 0,15
				P_SpawnParaloop(pmo.x, pmo.y, pmo.z+FixedMul(20*FRACUNIT, pmo.scale), 10*FRACUNIT, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, S_NIGHTSPARKLE1, false)
			end
			player.smhyper = false
			player.hyper_colorized = false
			pmo.momx = 0 pmo.momy = 0 pmo.momz = 0
			pmo.state = S_PLAY_FALL
			player.pflags = $ &~PF_JUMPED
            if (pmo.skin == "knuckles")
                player.chaoscooldown = 2*TICRATE
            end
		end
		if player.smhyper and not extrachars[player.mo.skin]
			player.smhyper = false
            player.normalspeed = skins[pmo.skin].normalspeed
		end
		if (S_MusicName() == "hprmet" or (S_MusicName() == "chsknx") or (S_MusicName() == "sshyp"))
        and not (player.smhyper)
            if (player.chaos_aura and player.chaos_aura.valid)
                player.pflags = $&~PF_GODMODE
                player.chaos_aura.flags2 = $|MF2_DONTDRAW
                P_RemoveMobj(player.chaos_aura)
            end
			P_RestoreMusic(player)
		end
        if ((S_MusicName() == "chsknx")) 
        and not (pmo.skin == "knuckles")
            if (player.chaos_aura and player.chaos_aura.valid)
                player.pflags = $&~PF_GODMODE
                player.chaos_aura.flags2 = $|MF2_DONTDRAW
                P_RemoveMobj(player.chaos_aura)
            end
		end
		if (player.hyper_music == false and player.smhyper)
		and (S_MusicName() == "hprmet" or (S_MusicName() == "chsknx") or (S_MusicName() == "sshyp"))
			S_ChangeMusic(player.last_music, true, player)
            if (player.chaos_aura and player.chaos_aura.valid)
                player.pflags = $&~PF_GODMODE
                player.chaos_aura.flags2 = $|MF2_DONTDRAW
                P_RemoveMobj(player.chaos_aura)
            end
		end
		if player.smhyper and not (player.powers[pw_super])
		or player.playerstate ~= PST_LIVE
			player.smhyper = false
            player.pflags = $&~PF_GODMODE //Chaos Knux
            if (player.chaos_aura and player.chaos_aura.valid)
                P_RemoveMobj(player.chaos_aura)
            end
		end
		if player.flying and not flyingchars[player.mo.skin]
			pmo.flags = $ &~MF_NOGRAVITY
			player.flying = false
		end
		if player.hflying and not pmo.skin == "sonic"
		or not (player.powers[pw_super])
			pmo.flags = $ &~MF_NOGRAVITY
			player.hflying = false
		end
			if player.digging
            and not player.mo.skin == "knuckles"
				player.digging = 0
				pmo.height = skins[pmo.skin].height
			end
		end
		if not player.smhyper
			player.hyper_colorized = false
        if player.normalspeed == hyperspeed
            player.normalspeed = normalspeed
        end
	end
end)

addHook("MobjMoveCollide", function(pmo, mo)
	if pmo and pmo.valid and pmo.health and pmo.player.smhyper
		if mo and mo.valid and (mo.health >= 3)
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (pmo.z > mo.z+mo.height)
				and not (mo.z > pmo.z+pmo.height)
					if not (mo.flags2 & MF2_FRET)
                    and not (mo.flags & MF_PAIN)
                    and not (mo.state == mo.info.painstate)
						S_StartSound(mo, sfx_buzz2)
                        P_StartQuake(50*FRACUNIT, TICRATE/4)
                        pmo.momx = -pmo.momx
                        pmo.momy = -pmo.momy
                        pmo.momz = -pmo.momz
					end
                    P_DamageMobj(mo, pmo, pmo.target, 3)
				end
			end
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(pmo, mo)
	if pmo and pmo.valid and pmo.health and (pmo.player.smhyper)
		if mo and mo.valid and (mo.info.spawnhealth > 1)
        and (mo.health == 3 or mo.health < 3)
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (pmo.z > mo.z+mo.height)
				and not (mo.z > pmo.z+pmo.height)
					if not (mo.flags2 & MF2_FRET)
                    and not (mo.flags & MF_PAIN)
                        P_KillMobj(mo, pmo, pmo)
						S_StartSound(mo, sfx_buzz2)
                        P_StartQuake(50*FRACUNIT, TICRATE/4)
                        pmo.momx = -pmo.momx
                        pmo.momy = -pmo.momy
                        pmo.momz = -pmo.momz
					end
				end
			end
		end
	end
end, MT_PLAYER)

local function spikegoboom(spike, plmo)
    if not (plmo and plmo.valid and plmo.player) return end
	local p = plmo.player
	if (p.smhyper or p.darkform or p.sboosting or p.spike_breaktime or p.digging == 1)
		if not  ((plmo.z > spike.z+spike.height+20*FRACUNIT) or (plmo.z+plmo.height+20*FRACUNIT < spike.z))
			P_KillMobj(spike, plmo, plmo)
			P_StartQuake(10*FRACUNIT, 4)
			return false
		end
	end
end

local function eggheadpain(egghead, plmo)
    if not (plmo and plmo.valid and plmo.player) return end
    if (plmo.skin ~= "sonic") return end
	local p = plmo.player
	if (p.smhyper or p.sboosting)
		if not  ((plmo.z > egghead.z+egghead.height+20*FRACUNIT) or (plmo.z+plmo.height+20*FRACUNIT < egghead.z))
			P_DamageMobj(egghead, plmo, plmo, 2)
			P_StartQuake(7*FRACUNIT, 4)
			return false
		end
	end
end

addHook("MobjCollide", spikegoboom, MT_SPIKE)
addHook("MobjCollide", spikegoboom, MT_TURRET)
addHook("MobjCollide", spikegoboom, MT_CYBRAKDEMON_ELECTRIC_BARRIER)
addHook("MobjCollide", spikegoboom, MT_EGGSHIELD)
addHook("MobjCollide", spikegoboom, MT_EGGROBO1)
addHook("MobjCollide", spikegoboom, MT_WALLSPIKE)
