local ENERGY_MAX = 200
local BOOST_MAXSPEED = 50*FRACUNIT
local BOOST_MIDSPEED = 40*FRACUNIT
local BOOST_MINSPEED = 20*FRACUNIT

freeslot(
"MT_METALIXSHOT", 
"MT_METALIXSHOT2", 
"MT_METALIXSHOT3", 
"S_PLAY_CHARGE", 
"S_PLAY_BLAST")

addHook("MobjSpawn", function(mo)
	if (mo and mo.valid)
	and mo.type == MT_METALIXSHOT
		S_StartSound(metalix, sfx_s3k54)
		mobjinfo[mo.type].height = mobjinfo[MT_ENERGYBALL].height
		mobjinfo[mo.type].radius = mobjinfo[MT_ENERGYBALL].radius
	end
end, MT_METALIXSHOT)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	
	
		if player.mo.skin == "metalsonic"
			if player.energy == nil
				player.energy = ENERGY_MAX
				end
			if player.flying == nil
				player.flying = false
				end
			if player.boosting == nil
				player.boosting = false
			end
			if player.boost_charge == nil
				player.boost_charge = 0
			end
            if not player.saved_boost_charge
				player.saved_boost_charge = 0
			end
			if player.boost == nil
				player.boost = 0
			end
			if player.floating == nil
				player.floating = false
			end
			if player.beaming == nil
				player.beaming = false
			end
			if player.cooldown == nil
				player.cooldown = 0
			end
			if player.stop_regeneration_man == nil
				player.stop_regeneration_man = false
			end
			if player.beam_energy == nil
				player.beam_energy = 0
			end
			if not player.jets
				player.jets = 0
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid
	
		if player.flying
			player.flying = false
			player.mo.flags = $ &~MF_NOGRAVITY
		end
		player.energy = ENERGY_MAX
		player.cooldown = 40
		player.beam_energy = 0
		player.beaming = 0
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "metalsonic" and (player.playerstate == PST_LIVE)
		
		local metalix = player.mo //Sonic Heroes
		local commanders = player.cmd
		local z = metalix.z
		local floorz = metalix.floorz
		
		if not player.tappingtossflag
			player.tappingtossflag = 0
		end
		
		if player.holdingflightbutton == nil
			player.holdingflightbutton = false
		end
		
		if player.multi_shot == nil
			player.multi_shot = false
		end
		
		if player.hyper_shot == nil
			player.hyper_shot = false
		end
		
		if player.can_regenenergy == nil
			player.can_regenenergy = true
		end
		
			if (metalix.eflags & MFE_UNDERWATER)
			player.powers[pw_underwater] = 0
			end
			if P_InSpaceSector(metalix)
			player.powers[pw_spacetime] = 0
			end	
			
				if ((player.cmd.buttons & BT_JUMP) or (player.cmd.buttons & BT_USE))
					player.holdingflightbutton = true
				else
					player.holdingflightbutton = false
				end
			
			if player.cmd.buttons & BT_TOSSFLAG
				and not P_IsObjectOnGround(metalix)
				and not P_PlayerInPain(player)
				and not player.powers[pw_carry]
				and not (player.exiting)
				and not (player.beaming or player.boost_charge)
				and player.energy
					if (player.tappingtossflag ~= true)
						if (player.flying == false)
							player.flying = true
							player.charability2 = CA2_NONE
						else
							player.flying = false
							player.charability2 = CA2_SPINDASH
							metalix.flags = $ &~MF_NOGRAVITY
							metalix.state = S_PLAY_FALL
						end
					end
				end
				
			if ((player.cmd.buttons & BT_TOSSFLAG))
				player.tappingtossflag = true
			else
				player.tappingtossflag = false
			end
			
			if P_PlayerInPain(player)
				player.flying = 0
				metalix.flags = $ &~MF_NOGRAVITY
			end
			
			if (player.can_regenenergy == false) and not player.flying and not player.beaming
				if ((leveltime % TICRATE == 0))
					player.can_regenenergy = true
				end
			end
			
			if not player.flying
				player.pflags = $ &~PF_CANCARRY
				if player.charability2 == CA2_NONE
					player.charability2 = CA2_SPINDASH
				end
			end
			
			if (player.cmd.buttons & BT_CUSTOM1)
			and player.energy >= 30 and not player.cooldown and not (player.powers[pw_carry])
			and not player.boost_charge
                player.can_regenenergy = false
                player.beam_energy = $ + 1
                if not player.beaming 
                    player.beaming = true
                    //if not netgame 
                        S_StartSound(metalix, sfx_s3k53) 
					//end
				end
			end
			
			//God, this is so messy
			
			if not ((player.cmd.buttons & BT_CUSTOM1)) or (player.beam_energy >= 150) 
				if player.beaming and not player.cooldown and player.beam_energy >= 5
					player.beaming = false
					if not player.smhyper
						player.cooldown = 40
					end
					player.beam_energy = 0
					P_InstaThrust(metalix, metalix.angle, -3*FRACUNIT)
					player.jets = 10
					if not player.hyper_shot
						local energy_shot = P_SpawnPlayerMissile(metalix, MT_METALIXSHOT, MF2_SCATTER)
						energy_shot.angle = metalix.angle
						P_InstaThrust(energy_shot, energy_shot.angle, mobjinfo[MT_ENERGYBALL].speed)
					end
					player.energy = $ - 10
					if player.multi_shot
						local energy_shot2 = P_SpawnPlayerMissile(metalix, MT_METALIXSHOT, MF2_SCATTER)
						energy_shot2.angle = metalix.angle+ANG10
						P_InstaThrust(energy_shot2, energy_shot2.angle, mobjinfo[MT_ENERGYBALL].speed)
						local energy_shot3 = P_SpawnPlayerMissile(metalix, MT_METALIXSHOT, MF2_SCATTER)
						energy_shot3.angle = metalix.angle-ANG10
						P_InstaThrust(energy_shot3, energy_shot3.angle, mobjinfo[MT_ENERGYBALL].speed)
						player.energy = $ - 20
						player.multi_shot = false
					end
				end
			end
			if player.cooldown
				player.cooldown = $ - 1
			end	
			if player.beam_energy >= 35 or (player.powers[pw_super])
				player.multi_shot = true
			end
			if player.jets
				metalix.state = S_PLAY_BLAST
				metalix.momz = 0
				player.jets = $ - 1
			end
			if player.beaming or (player.boost <= 0 and player.boost_charge)
				player.drawangle = metalix.angle
				player.beam_energy = $ + 1
				player.powers[pw_nocontrol] = 10
				metalix.state = S_PLAY_CHARGE
				if (commanders.buttons & BT_TOSSFLAG) and (z - floorz < metalix.height) and not player.flying
					P_SetObjectMomZ(metalix, FRACUNIT, false)
				else
					metalix.momz = 0
					metalix.momx = 0
					metalix.momy = 0
				end
			end
			
			if (S_SoundPlaying(metalix, sfx_s3k53) and not player.beaming)
				S_StopSoundByID(metalix, sfx_s3k53)
			end
			
			if player.energy < 0
				player.energy = 0
			end
			
			if (player.can_regenenergy == true) and player.energy < ENERGY_MAX
				if ((leveltime % 7 == 0))
					player.energy = $ + 1
				end
			end
			
			if player.energy < 1 or (player.pflags & PF_STASIS or player.powers[pw_carry] or player.pflags & PF_FULLSTASIS 
			or (player.exiting) and not player.beaming) //No energy, no powa
				if player.flying
					metalix.state = S_PLAY_FALL
					player.flying = false
					metalix.flags = $ &~MF_NOGRAVITY
				end
				player.floating = false
			end
			
			if player.energy == 0
				if not P_IsObjectOnGround(metalix)
					player.stop_regeneration_man = true
				end
			end
			
			if (player.cmd.buttons & BT_CUSTOM3)
			and player.energy >= 30 and not player.cooldown and not (player.powers[pw_carry])
			and not player.boost and not P_PlayerInPain(player)
                player.saved_boost_charge = player.boost_charge
				if ((leveltime % 2 == 0))
					player.can_regenenergy = false
					if (player.boost_charge < 70*FRACUNIT)
						player.boost_charge = $ + FRACUNIT
                        player.saved_boost_charge = player.boost_charge
						metalix.state = S_PLAY_CHARGE
							if not S_SoundPlaying(metalix, sfx_cdfm71)
							and (player.boost_charge < BOOST_MAXSPEED)
							S_StartSound(metalix, sfx_cdfm71)
						end
					end
				end
			end
			
			if S_SoundPlaying(metalix, sfx_cdfm71)
			and not player.boost_charge
				S_StopSoundByID(metalix, sfx_cdfm71)
			end
			
			if P_PlayerInPain(player)
			and player.boosting
				player.boosting = false
				player.dashmode = 0
				player.normalspeed = 36*FRACUNIT
				player.drawangle = metalix.angle
				P_InstaThrust(metalix, metalix.angle, -4*FRACUNIT)
			end
			
			if not ((player.cmd.buttons & BT_CUSTOM3)) or (player.saved_boost_charge >= 70*FRACUNIT)
				if (player.saved_boost_charge)
					if not (player.smhyper)
						player.boost = 50
                        player.saved_boost_charge = 0
						player.boosting = true
						player.dashmode = 3*TICRATE
						metalix.state = S_PLAY_DASH
						S_StartSound(metalix, sfx_s3k54)
						S_StopSoundByID(metalix, sfx_cdfm71)
					else
						player.saved_boost_charge = 0
						player.boost = 90
						player.boosting = true
						player.dashmode = 3*TICRATE
						metalix.state = S_PLAY_DASH
						P_StartQuake(20*FRACUNIT, 4)
						P_NukeEnemies(metalix, metalix, 2214*FRACUNIT)
						P_FlashPal(player, PAL_NUKE, 5)
						S_StartSound(metalix, sfx_bkpoof)
						S_StopSoundByID(metalix, sfx_cdfm71)
					end
				end
			end
            
            if not (player.boosting)
            and not ((player.cmd.buttons & BT_CUSTOM3))
                player.boost_charge = 0
            end
			
			if player.boosting
			local nextsec = R_PointInSubsector(metalix.x + metalix.momx, metalix.y + metalix.momy).sector
                if player.boost_charge < 30*FRACUNIT
                    player.boosting = false
                    player.boost = 0
                    player.boost_charge = 0
                elseif player.boost_charge >= 30*FRACUNIT
                    P_InstaThrust(metalix, metalix.angle, 30*FRACUNIT)
                elseif player.boost_charge >= 50*FRACUNIT
                    P_InstaThrust(metalix, metalix.angle, 50*FRACUNIT)
                elseif player.boost_charge >= 70*FRACUNIT
                    P_InstaThrust(metalix, metalix.angle, 70*FRACUNIT)
				elseif player.smhyper
					P_InstaThrust(metalix, metalix.angle, 70*FRACUNIT*3)
				end
				player.drawangle = metalix.angle
				if (not nextsec or (nextsec.ceilingheight - nextsec.floorheight <= metalix.height)) then
					P_BounceMove(metalix)
					metalix.angle = R_PointToAngle2(0, 0, metalix.momx, metalix.momy)
				end
			end
			
			if player.boost_charge
			and (z - floorz < metalix.height/2) and not player.flying
				P_SetObjectMomZ(metalix, FRACUNIT, false)
			end
				
				
			
			if player.flying //1st Place
				if not (player.dashmode >= 3*TICRATE) and not (player.speed >= player.runspeed) and not player.beaming and not player.jets
					metalix.state = S_PLAY_WALK
				elseif (player.speed >= player.runspeed)
				and not (player.dashmode >= 3*TICRATE)
					metalix.state = S_PLAY_RUN
				elseif (player.dashmode >= 3*TICRATE)
					metalix.state = S_PLAY_DASH
					if (player.normalspeed < skins[player.skin].normalspeed*2) and (commanders.forwardmove or commanders.sidemove)
						player.normalspeed = $+FRACUNIT/5
					end
				end
				metalix.flags = $|MF_NOGRAVITY
				player.pflags = $ &~PF_SPINNING&~PF_JUMPED|PF_CANCARRY
				player.can_regenenergy = false
				player.panim = PA_WALK
				
				local ray = P_SpawnMobjFromMobj(metalix, 0,0,0, MT_RAY)
				ray.z = floorz*P_MobjFlip(metalix)
				if P_CheckDeathPitCollide(ray)
				//There's a pit
		
				elseif P_IsObjectOnGround(metalix) or z - floorz < metalix.height/2
					metalix.momz = $+(2*metalix.scale*P_MobjFlip(metalix))
				end
			if not G_RingSlingerGametype()
				if ((leveltime % 10 == 0))
						player.energy = $ - 1
					end
				end
			if G_RingSlingerGametype()
				if ((leveltime % 2 == 0) and not player.powers[pw_carry])
						player.energy = $ - 1
					end
				end
				if (player.cmd.buttons & BT_JUMP)
					if (metalix.momz < 12*FRACUNIT)
						P_SetObjectMomZ(metalix, FRACUNIT/2, true)
						player.holdingflightbutton = true
					end
				end
			end
			if player.flying
				if (player.cmd.buttons & BT_USE)
					if (metalix.momz > -12*FRACUNIT)
						P_SetObjectMomZ(metalix, -FRACUNIT/2, true)
						player.holdingflightbutton = true
					end
				end
			end
			if player.flying
				if not (player.cmd.forwardmove or player.cmd.sidemove)
					metalix.momx = $*30/31
					metalix.momy = $*30/31
				end
				if (player.holdingflightbutton ~= true)
					if ((metalix.momz >= -metalix.scale) and (metalix.momz <= metalix.scale))
						metalix.momz = 0
					elseif not ((metalix.momz >= -metalix.scale) and (metalix.momz <= metalix.scale))
						if (player.holdingflightbutton ~= true)
							metalix.momz = $*30/31
						end
					end
				end
			end
			if player.powers[pw_super]
				player.energy = ENERGY_MAX
			end
			if not player.powers[pw_super]
				player.smhyper = false
			end
			if (player.dashmode < 3*TICRATE)
				if (player.boosting)
				player.boosting = false
				end
			end			
			if (player.boost > 0)
				player.boost = $ - 1
			else
				player.boosting = false
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "metalsonic" and player.smhyper

			local pmo = player.mo
			local pmo = player.mo
			local normalspeed = skins["metalsonic"].normalspeed
			local hyperspeed = skins["metalsonic"].normalspeed*2
			
			if (S_MusicName() == "_super")
				if (player.hyper_music == true)
					P_PlayJingleMusic(player, "HPRMET", 0, true, JT_OTHER)
				end
			end
				player.normalspeed = hyperspeed
				if player.hyper_colorized
					pmo.color = (SKINCOLOR_HYPER_METAL1 + abs( ( (leveltime >> 1) % 9) - 4))
				end
				local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(0, 50) * FRACUNIT, MT_WATERZAP)
				electric.color = pmo.color
				electric.frame = $|FF_FULLBRIGHT
				electric.colorized = true
				if (player.speed > 2*FRACUNIT or pmo.momz > 2*FRACUNIT or pmo.momz < -1*FRACUNIT)
				and (leveltime % 2 == 1)
					local ghost1 = P_SpawnGhostMobj(pmo)
					ghost1.color = pmo.color
					ghost1.colorized = true
					ghost1.rollangle = pmo.rollangle
					ghost1.fuse = 5
					ghost1.blendmode = AST_ADD
					ghost1.eflags = pmo.eflags & MFE_VERTICALFLIP
			end	
		end
	end
end)


local function hudstuff2(v, player, cam)
	if (player.mo and player.mo.skin == "metalsonic" and player.energy != nil)
		v.drawString(18, 155, "Energy:", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ORANGEMAP|V_HUDTRANS|V_PERPLAYER)
		if not player.powers[pw_super] or player.mysticsuper
			v.drawString(18,165, player.energy+"/200", 
			V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ORANGEMAP|V_PERPLAYER|V_HUDTRANS)
		else
			v.drawString(18,165,"/200", 
			V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_REDMAP|V_PERPLAYER|V_HUDTRANS)
		end
	end
end

hud.add(hudstuff2, player)

addHook("ShouldJingleContinue", function(player, musname)
    if musname != "hprmet" return end
    if (player.smhyper)
        return true
    else
        return false
    end
end)

local windows10
addHook("PreThinkFrame", function(r)
	windows10 = S_GetMusicPosition()
end)

addHook("MusicChange", function(sus, mogus)
	if (gamestate != GS_LEVEL) or (consoleplayer.hyper_music ~= true) return end
	if (consoleplayer and consoleplayer.mo 
	and consoleplayer.mo.valid and consoleplayer.mo.health
	and consoleplayer.smhyper)
	and (mogus == "_shoes" or mogus == "_inv" or mogus == "_minv" or mogus == mapmusname)
		if sus == "hprmet"
			return true
		else
			return "hprmet", 0, true, windows10
		end
	end
end)

addHook("MobjMoveBlocked", function(m)
	if m.skin == "metalsonic" and m.player
	and not m.player.powers[pw_carry]
	local metallix = m.player
	local metalsonic = m
	
		if metallix.boosting
			P_BounceMove(metalsonic)
			metalsonic.angle = R_PointToAngle2(0, 0, metalsonic.momx, metalsonic.momy)
			S_StartSound(metalsonic, sfx_s3kaa)
			if metallix.boost <= 5
				P_DoPlayerPain(metallix, nil, nil)
				metalsonic.angle = -metalsonic.angle
				S_StartSound(metalsonic, sfx_mspogo)
				S_StopSoundByID(metalsonic, sfx_s3kaa)
			end
		end
	end
end, MT_PLAYER)
	