//Dark Sonic(WIP)
freeslot("MT_DARK_SONIC","MT_DARKBEAM", "SPR_DSTD", "SPR_DTNS", "SPR_DWLK", "SPR_DRN_",
"SPR_DFT_", "SPR_DSTN", "SPR_DPAI", "SPR_DRLL", "SPR_DGSP", "SPR_DSPG",
"SPR_DFLL", "SPR_DEDG", "SPR_DRDE", "SPR_NTHK", "sfx_drkthk")

freeslot("MT_DARKSLASER")
mobjinfo[MT_DARKSLASER] = {
	doomednum = -1,
    spawnstate = mobjinfo[MT_THROWNEXPLOSION].spawnstate,
    spawnhealth = 1,
    seestate = S_NULL,
    seesound = sfx_s3k54,
    reactiontime = 8,
    attacksound = sfx_None,
    painstate = S_NULL,
    painchance = mobjinfo[MT_THROWNEXPLOSION].painchance,
    painsound = sfx_None,
    meleestate = S_NULL,
    missilestate = S_NULL,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_None,
    speed = mobjinfo[MT_THROWNEXPLOSION].speed,
    radius = mobjinfo[MT_THROWNEXPLOSION].radius,
    height =  mobjinfo[MT_THROWNEXPLOSION].height,
    dispoffset = 1,
    mass = 16,
    damage = 1*FRACUNIT,
    activesound = sfx_None,
    flags = mobjinfo[MT_THROWNEXPLOSION].flags,
}

local function DarkLaserThinker(mo)
	local x, y, z = mo.x, mo.y, mo.z

	if mo.momx ~= 0 or mo.momy ~= 0
		if not P_TryMove(mo, mo.x + mo.momx*3/2, mo.y + mo.momy*3/2, true) return true end
		if not mo.valid return true end
	end

	if mo.momz ~= 0
		mo.z = $ + mo.momz*3/2
		if mo.z < mo.floorz or mo.z + mo.height > mo.ceilingz return true end
	end

	return not mo.valid or x == mo.x and y == mo.y and z == mo.z
end

local function DarkLaser(mo, long)
	local nblockmap = not (mo.flags & MF_NOBLOCKMAP)

	for i = 0, 256
		if nblockmap
			mo.flags = $ | MF_NOBLOCKMAP
		end

		local p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale*3/2
		p.destscale = 1
		p.scalespeed = mo.scale*3/2/12
		p.sprite = SPR_NTHK
		p.frame = A|FF_FULLBRIGHT
		p.color = i%2 and SKINCOLOR_BLACK or SKINCOLOR_GREY
		p.tics = TICRATE

		p = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		p.scale = mo.scale*3/2*3/2
		p.destscale = 1
		p.sprite = SPR_NTHK
		p.frame = A|TR_TRANS80|FF_FULLBRIGHT
		p.scalespeed = mo.scale*3/2/12
		p.color = SKINCOLOR_WHITE
		p.tics = TICRATE

		if DarkLaserThinker(mo)
			break
		end
	end
	mo.scale = $*4
	P_ExplodeMissile(mo)
end

local TELEPORT_TIMES = 3

mobjinfo[MT_DARK_SONIC] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

addHook("MobjSpawn", function(mobj)
	mobj.shadowscale = FRACUNIT
end, MT_DARK_SONIC)

addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid and mobj and mobj.valid) return true end
	if player.darkform
		mobj.skin = player.mo.skin
		mobj.state = player.mo.state
		mobj.frame = player.mo.frame
        if (player.mo.state == S_PLAY_STND)
            mobj.sprite = SPR_DSTD
        elseif (player.mo.state == S_PLAY_WALK or player.skidtime)
            mobj.sprite = SPR_DWLK
        elseif (player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_FLOAT_RUN)
            mobj.sprite = SPR_DRN_
        elseif (player.mo.state == S_PLAY_FLOAT)
            mobj.sprite = SPR_DFT_
        elseif (player.mo.state == S_PLAY_STUN)
            mobj.sprite = SPR_DSTN
        elseif (player.mo.state == S_PLAY_PAIN)
            mobj.sprite = SPR_DPAI
        elseif (player.mo.state == S_PLAY_GASP)
            mobj.sprite = SPR_DGSP
        elseif (player.mo.state == S_PLAY_SPRING)
            mobj.sprite = SPR_DSPG
        elseif (player.mo.state == S_PLAY_FALL)
            mobj.sprite = SPR_DFLL
        elseif (player.mo.state == S_PLAY_EDGE)
            mobj.sprite = SPR_DEDG
        elseif (player.mo.state == S_PLAY_RIDE)
            mobj.sprite = SPR_DRDE
        elseif (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_JUMP)
            mobj.sprite = SPR_DRLL
        elseif (player.mo.state >= S_PLAY_SUPER_TRANS1 and player.mo.state <= S_PLAY_SUPER_TRANS6)
            mobj.sprite = SPR_DTNS
        end
		mobj.angle = player.drawangle
		mobj.color = SKINCOLOR_BLACK
		mobj.colorized = player.mo.colorized
		mobj.scale = player.mo.scale
		mobj.radius = player.mo.radius
		mobj.height = player.mo.height
		mobj.flags2 = player.mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		mobj.eflags = player.mo.eflags&MFE_VERTICALFLIP
		player.mo.flags2 = $|MF2_DONTDRAW
		mobj.flags2 = $&~MF2_LINKDRAW
	elseif mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
	end
	P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z)
	return true
end, MT_DARK_SONIC)

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.skin == "sonic") then return end

	//Super afterimage code ported from the source code
	if (player.darkform)
	and player.speed + abs(player.mo.momz) > FixedMul(20*FRACUNIT,player.mo.scale)
		local gmobj = P_SpawnGhostMobj(player.mo)
		gmobj.fuse = 2
        gmobj.color = player.mo.color
        gmobj.colorized = true
        gmobj.rollangle = player.mo.rollangle
        gmobj.blendmode = AST_TRANSLUCENT
        gmobj.eflags = player.mo.eflags & MFE_VERTICALFLIP
		if gmobj.tracer then gmobj.tracer.fuse = 2 end
		if (leveltime & 1)
			gmobj.frame = $&~FF_TRANSMASK
			gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
			if (gmobj.tracer)
				gmobj.tracer.frame = $&~FF_TRANSMASK
				gmobj.tracer.frame = $|tr_trans70<<FF_TRANSSHIFT
			end
		end
	end
end)

local function P_RingNearby(player) -- Is a ring in range?
    local closest
	closest = NULL

	for mo in mobjs.iterate()

		if (mo.health <= 0) -- Not a valid ring
			continue
        end

		if not (mo.flags & MF_ENEMY|MF_BOSS)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 1000*FRACUNIT) -- Out of range
			continue
        end

		if not P_CheckSight(player.mo, mo) -- Out of sight
			continue
        end

		if (closest and P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > P_AproxDistance(P_AproxDistance(player.mo.x-closest.x,
			player.mo.y-closest.y), player.mo.z-closest.z))
			continue
        end

		-- Found a target
		closest = mo
    end

	if closest then
		return true
    end

	return false
end

local function DarkHomingTeleport(player)
    local found
    player.mo.target = NULL
    player.mo.tracer = NULL

	for mo in mobjs.iterate()

		if (mo.health <= 0) then -- Not a valid ring
			continue
        end

		if not (mo.flags & MF_ENEMY or mo.flags & MF_BOSS)
			continue
        end

		if (P_AproxDistance(P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y),
			player.mo.z-mo.z) > 1000*FRACUNIT) -- Out of range
			continue
        end

		if not P_CheckSight(player.mo, mo) -- Out of sight
			continue
        end

		if (player.mo.target and P_AproxDistance(P_AproxDistance(player.mo.x-mo.x,
			player.mo.y-mo.y), player.mo.z-mo.z) >
			P_AproxDistance(P_AproxDistance(player.mo.x-player.mo.target.x,
			player.mo.y-player.mo.target.y), player.mo.z-player.mo.target.z))
			continue
        end

		-- Found a target
		found = true
		player.mo.target = mo
		player.mo.tracer = mo
	end

	if found then
		player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.target.x, player.mo.target.y)
        P_TeleportMove(player.mo, player.mo.target.x, player.mo.target.y, player.mo.target.z)
    elseif not player.mo.target
        local mo = player.mo
        mo.state = S_PLAY_FALL
        P_SpawnGhostMobj(mo)
        S_StartSound(mo, sfx_drkthk)
        mo.momz = 0
        P_InstaThrust(mo,
        player.drawangle,
        FixedMul(player.actionspd, mo.scale))
		return
    end
end

addHook("ThinkFrame", do
	for player in players.iterate
	 if player.mo and player.mo.valid
		if player.mo.skin == "sonic"
		
            local pmo = player.mo

                if player.darkform
                    
                    if (leveltime % 35 == 18)
                        P_GivePlayerRings(player, -1)
                    end
                
                    if not player.darkenergy
                        player.darkenergy = 20000
                    end
                    
                    if player.darkshield == nil
                        player.darkshield = 200
                    end
                    
                    if player.darkshield < 0
                        player.darkshield = 0
                    end
                
                    if player.darkshield < 200 and not (player.powers[pw_flashing])
                        if ((leveltime % 10 == 0))
                            player.darkshield = $+1
                        end
                    end
                    
                
                    if (S_MusicName() == "_super" or S_MusicName() == "sshyp")
                        if (player.hyper_music == true)
                            P_PlayJingleMusic(player, "DARSON", 0, true, JT_OTHER)
                        end
                    end
                    
                    if not player.cdshot
                        player.cdshot = TICRATE/4
                    end
                    
                    if (player.pflags & PF_THOKKED)
                        local ghost2 = P_SpawnGhostMobj(pmo)
                        ghost2.colorized = true
                        ghost2.color = pmo.color
                        ghost2.rollangle = pmo.rollangle
                        ghost2.fuse = 5
                        ghost2.blendmode = AST_ADD
                        ghost2.eflags = pmo.eflags & MFE_VERTICALFLIP
                    end
                    if (player.cmd.buttons & BT_ATTACK) and not player.dontallowfire
                        local msl = P_SpawnPlayerMissile(pmo, MT_DARKSLASER, MF2_EXPLOSION)
                        if not msl return end
                        DarkLaser(msl, true)
                    end
                    if (pmo.eflags & MFE_UNDERWATER)
                        player.powers[pw_underwater] = 0
                    end
                    if P_InSpaceSector(pmo)
                        player.powers[pw_spacetime] = 0
                    end
                    pmo.color = (SKINCOLOR_DARK_SONIC1 + abs( ( (leveltime >> 1) % 9) - 4))
                    if not(player.dark_aura and player.dark_aura.valid)
                    and (player.darkshield >= 100)
                        player.dark_aura = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_CHAOSKNUXAURA)
                        player.dark_aura.state = S_DARKAURA1
                    end                                       
                    if player.darkshield == 0 and (player.dark_aura and player.dark_aura.valid)
                        P_RemoveMobj(player.dark_aura)
                    end
                    if (player.dark_aura and player.dark_aura.valid)
                        player.dark_aura.color = SKINCOLOR_BLACK
                        player.dark_aura.scale = pmo.scale
                        player.dark_aura.flags = $|MF_MISSILE
                        player.dark_aura.flags2 = $&~MF2_DONTDRAW|MF2_SCATTER
                        player.dark_aura.colorized = true
                        player.dark_aura.blendmode = AST_ADD
                        player.dark_aura.target = pmo
                    end
                    player.smhyper = false
                    local electric = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(-20, 20) * FRACUNIT, P_RandomRange(0, 50) * FRACUNIT, MT_WATERZAP)
                    electric.color = pmo.color
                    electric.frame = $|FF_FULLBRIGHT
                    electric.colorized = true
                end
            end
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "sonic") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
		if (mo.previousx == nil) or (mo.previousy == nil) or (mo.previousz == nil)
			mo.previousx = mo.x
			mo.previousy = mo.y
			mo.previousz = mo.z
		end
        if (mo.prevstate == nil)
			mo.prevstate = mo.state
		end
        if not player.darkform
            if (player.dark_aura and player.dark_aura.valid)
                P_RemoveMobj(player.dark_aura)
            end
        end
		if player.darkform
        local pmo = mo
           if (player.dark_aura and player.dark_aura.valid)
                player.dark_aura.color = SKINCOLOR_BLACK
                player.dark_aura.scale = pmo.scale
                player.dark_aura.flags = $|MF_MISSILE
                player.dark_aura.flags2 = $&~MF2_DONTDRAW|MF2_RAILRING
                player.dark_aura.eflags = pmo.eflags
                player.dark_aura.colorized = true
                player.dark_aura.blendmode = AST_ADD
                A_CapeChase(player.dark_aura, 0, 0)
            end
		end
		mo.previousx = mo.x
		mo.previousy = mo.y
		mo.previousz = mo.z
        mo.prevstate = mo.state
	end
end)

addHook("MobjMoveCollide", function(pmo, mo)
	if pmo and pmo.valid and pmo.health and pmo.player.darkform
		if mo and mo.valid and (mo.health > 4)
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (pmo.z > mo.z+mo.height)
                and not (mo.z > pmo.z+pmo.height)
                and not (mo.info.mass == 2006)
					if not (mo.flags2 & MF2_FRET)
                    and not (mo.flags & MF_PAIN)
                    and not (mo.state == mo.info.painstate)
						S_StartSound(mo, sfx_buzz2)
                        P_StartQuake(50*FRACUNIT, TICRATE/4)
                        pmo.momx = -pmo.momx
                        pmo.momy = -pmo.momy
                        pmo.momz = -pmo.momz
					end
                    P_DamageMobj(mo, pmo, pmo.target, 4)
				end
			end
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(pmo, mo)
	if pmo and pmo.valid and pmo.health and pmo.player.darkform
		if mo and mo.valid and (mo.info.spawnhealth > 1)
        and (mo.health == 4 or mo.health < 4)
			if mo.flags & MF_ENEMY
			or mo.flags & MF_BOSS
			or mo.flags & MF_MONITOR
				if not (pmo.z > mo.z+mo.height)
                and not (mo.z > pmo.z+pmo.height)
                and not (mo.info.mass == 2006)
					if not (mo.flags2 & MF2_FRET)
                    and not (mo.flags & MF_PAIN)
                        P_KillMobj(mo, pmo, pmo)
                        P_StartQuake(50*FRACUNIT, TICRATE/4)
                        pmo.momx = -pmo.momx
                        pmo.momy = -pmo.momy
                        pmo.momz = -pmo.momz
					end
				end
			end
		end
	end
end, MT_PLAYER)

addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid
		if player.mo.skin == "sonic" and not player.smhyper and player.darkform
			if not (player.pflags & PF_THOKKED) and not player.doublejumped //You cant speed thok but you can speed homing attack
				player.actionspd = 70*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, player.actionspd)
				player.drawangle = player.mo.angle
				S_StartSound(player.mo, sfx_drkthk)
				P_SpawnThokMobj(player)
				player.pflags = $ | PF_THOKKED
			end
		end
	end
end)

addHook("ShouldDamage", function(mobj, i, so, dmg, dmgtype)
	if(mobj.player and mobj.player.valid)
		and (mobj.player.powers[pw_flashing])
		return end
    // Take damage
    if (mobj and mobj.player and mobj.player.darkform)
        if(dmgtype) and not (mobj.player.powers[pw_flashing])
            if (dmgtype == DMG_DEATHPIT or dmgtype == DMG_CRUSHED)
                P_SetObjectMomZ(mobj, 30*FRACUNIT, false)
                mobj.state = S_PLAY_SPRING
                mobj.player.pflags = $|PF_JUMPED
                // Burst all the things! (except rings)                       
                // Take knockback!
                if(mobj.player.darkshield >= 50)	// Not dead yet!
                    mobj.player.powers[pw_flashing] = 70	// Apply invincibility so we don't *actually* take damage (we already did!)
                    mobj.player.powers[pw_invulnerability] = 30
                    mobj.player.darkshield = $-100
                    return false
                end
            end
        end
    end
end)

addHook("ShouldJingleContinue", function(player, musname)
    if musname != "darson" return end
    if (player.darkform)
        return true
    else
        return false
    end
end)

local darksoggsters
addHook("PreThinkFrame", function(r)
	darksoggsters = S_GetMusicPosition()
end)

addHook("MusicChange", function(sus, mogus)
	if (gamestate != GS_LEVEL) or (consoleplayer.hyper_music ~= true) return end
	if (consoleplayer and consoleplayer.mo 
	and consoleplayer.mo.valid and consoleplayer.mo.health
	and consoleplayer.darkform)
	and (mogus == "_shoes" or mogus == "_inv" or mogus == "_minv" or mogus == mapmusname)
		if sus == "darson"
			return true
		else
			return "darson", 0, true, darksoggsters
		end
	end
end)

local function DarkHuD(v, player, cam)
	if (player.mo and player.mo.skin == "sonic" and player.darkshield != nil)
        if player.darkform
            v.drawString(18, 155, "Dark Shield Power:", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_INVERTMAP|V_HUDTRANS|V_PERPLAYER)
            if player.darkshield > 0
                v.drawFill(18, 165, player.darkshield*238/200, 6, (192 + leveltime%8)|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
            end
            local origvalue = v.localTransFlag() >> V_ALPHASHIFT
            local length = NUMTRANSMAPS - origvalue
            local pulse = abs(((leveltime/2) % (NUMTRANSMAPS*2)) - NUMTRANSMAPS)
            local trans = 0

            if (origvalue >= NUMTRANSMAPS)
                return
            end

            if (origvalue > 0)
                pulse = ($1 * length) / NUMTRANSMAPS
                trans = (origvalue + pulse)
            end

            if (trans < NUMTRANSMAPS)
                trans = $1 << V_ALPHASHIFT
                v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, hudinfo[HUD_LIVES].y*FRACUNIT, FRACUNIT/2, v.cachePatch("DTRAA0"), V_SNAPTOLEFT|V_PERPLAYER|trans, v.getColormap("no", player.mo.color))
            end

            trans = origvalue + (length - pulse)
		end
	end
end
hud.add(DarkHuD, player)